/*
 * Interpolator.h
 *
 *  Created on: Nov 20, 2013
 *      Author: mswindell
 */

#ifndef INTERPOLATOR_H_
#define INTERPOLATOR_H_

#include <vector>
#include "FileReader.h"

class Interpolator {
public:
    Interpolator();
    Interpolator(FileReader* fr);
    long open(std::string& filename);
    void close();
    void loadVariable(std::string& variable);
    float interpolate(const char* variable, const float* lat, const float* lon);
    float interpolate(const std::string variable, const float& r, const float& lat, const float& lon);
    //float iterpolate(const std::string& variable, const float& lat, const float& lon);
    int index_2D_to_1D(const int& ilat, const int& ilon);
    void getPositionData();

    //int binary_search(const std::vector<float>& vec, unsigned int start, unsigned int end, const float& key);


    virtual ~Interpolator();

private:

    
    FileReader* fileReader;
    std::string phi_string;
    std::string th_string;
    int phi_size;
    int theta_size;
    std::vector<float> * phi_data;
    std::vector<float>* th_data;
};


#endif /* INTERPOLATOR_H_ */
