/* 
 * File:   TimeInterpolator.h
 * Author: mswindell
 *
 * Created on December 5, 2013, 3:52 PM
 */

#ifndef TIMEINTERPOLATOR_H
#define	TIMEINTERPOLATOR_H

#include <string>
#include <map>
#include <vector>
#include "Time.h"
#include "FileReader.h"

class TimeInterpolator {
public:
    TimeInterpolator();
    void addTimestep(const std::string& filename);
    bool manageMemory(const Time& time, const std::vector<std::string>& variables);
    bool manageMemory(const Time& time, const char * variables[], int numVars);
    void closeAndCleanupMemory();
    float interpolate(const Time& time, const std::string& variable, const float& c0, const float& c1, const float& c2);
    static Time parseTime(const std::string& timeString);
    static std::string toString(const Time& time);
    virtual ~TimeInterpolator();
private:
    std::vector<Time> timesteps;
    std::map<Time, const std::string> timesteps_map;
    std::map<Time, FileReader *> current_files;
    bool isSorted;
    
    void manageVariables(const std::vector<std::string>& variables, FileReader* a);
    void manageVariables(const char * variables[], int numVars, FileReader* a);

};

#endif	/* TIMEINTERPOLATOR_H */

