
/*
 * time_interpolator_test.cpp
 *
 *  Created on: Dec 1, 2009
 *      Author: mswindell
 */

//#include <boost/lexical_cast.hpp>
#include "TimeInterpolator.h"
#include "Time.h"
#include <iostream>
#include <string>
#include <fstream>
#include <vector>

using namespace std;

int main(int argc, char * argv[]) {
    ifstream infile;
    ofstream outfile;
    infile.open("/Users/mswindell/newlist.txt");
    string path = "", line = "", filename = "";
    const string variable = "ep";
    const string model = "swmf";
    int status, i = 0;
    float lat = 89.0, lon = 12.0;

    std::vector<std::string> variables;
    string vars[] = {"ep", "eave", "eflux"};

    Time time = TimeInterpolator::parseTime(
            "2006/12/13T00:10:00.000Z");
    std::cout << "Example Time: " << TimeInterpolator::toString(time)
            << std::endl;
    TimeInterpolator timeInterp;
    while (getline(infile, line)) {
        if (line == "")
            break;
        //Combine filename read from a file with the path name
        //path = "/Volumes/HD-PATU3/data/E.2006.347/";
        path = "/Users/mswindell/data/E.2006.347/";
        filename = path.append(line);
        timeInterp.addTimestep(filename);
        i++;
    }

    for (int i = 0; i < 3; i++) {
        variables.push_back(vars[i]);
        for (int hour = 0; hour < 12; hour++) {
            time.setHour((short) hour);
            for (int minute = 0; minute < 30; minute++) {
                if (minute % 5 == 0)
                    continue;
                else {
                    time.setMinute((short) minute);
                    timeInterp.manageMemory(time, variables);
                    for (int j = 0; j < lat; j++) {
                        for (int k = 0; k < lon; k++) {

                            float value = timeInterp.interpolate(time, vars[i]
                                    , 0.0, j, k);
                            if (value == -1)
                                break;
                            std::cout << variables[i] << " interpolated value: "
                                    << value << " at lat:" << j << " lon:" << k
                                    << ": at time: " << time << std::endl;
                        }
                    }
                }
            }
        }
    }
    timeInterp.closeAndCleanupMemory();
    infile.close();
    outfile.close();
    cout << "Done.\n";

}
