      program kameleon_compat_f
c     My attempt at a fortran program. This is an example program
c     mainly to test the ionospheric output of SWMF
 
c     Three functions used to interpolate 
c     data from a specified batsrus cdf file
 
       external f_interpolator_create
       external f_interpolator_delete
       external f_interpolator_open
       external f_interpolator_load_variable
       external f_interpolator_interpolate
       external f_interpolator_close
 
c     Variables to be used for interpolation and data extraction

      character*300 cdf_file_path
      character*100 c0,c1,c2
      character*100 variable

c     r, lat, mlt for iono data
      real rc0, rc1, rc2
      real d0,d1,d2
      real interpolated_value
      real latdelta,mltdelta
      integer status,kid,iid, vid
      integer argc,zero
      zero = 0
 
c     --- set your actual path name here ---
      argc = iargc()

      if (argc.ne.2) then
        print *,"Must supply the filename and variable"
       call exit(1)
      endif

      call getarg(1, cdf_file_path)
      call getarg(2, variable)



c     this id will be set when calling f_kameleon_create. just
c     initialize it, since I have no idea if you need to initialize
c     variables in fortran
      kid=0
      vid=0
      call f_interpolator_create(iid)
c      print *, 'Created interpolator. iid = ', iid
      call f_interpolator_open(iid,cdf_file_path,status)
c      print *, 'done opening file'
c      print *, 'status = ', status
      call f_interpolator_load_variable(iid,variable)
c      print *, 'done loading variable ', variable
      latdelta = 180.0/(181.-1.)
      mltdelta = 24.0/(181.-1.)
      do j=0,180
        do i = 0, 180
          rc1 = 90 - i*latdelta
          rc2 = mod(12.+j*mltdelta, 24.)
c          print *, 'iid = ', iid
c          print *, 'variable = ', variable
c          print *, 'lat = ', rc1
c          print *, 'lon = ', rc2
c          print *, 'dr = ', d0
c          print *, 'dlat = ', d1
c          print *, 'dlon = ', d2
          call f_interpolator_interpolate(iid,variable,rc1,rc2,
     & interpolated_value)
          print *, ' lat: ', rc1, ' mlt: ', rc2,
     &' interpolated value: ', interpolated_value
        enddo
      enddo
      call f_interpolator_close(iid)
      print *, 'Closed the interpolator'
      call f_interpolator_delete(iid)
      print *, 'Deleted the interpolator'
 
        stop
      end 
      
